ResourcesWidget.controller = function ResourcesCtrl($rootScope, applicationsService , $log,
			$window, userProfileService, $scope, $cookies, $timeout, $interval,
			$uibModal, dashboardService, ngDialog) {
		
		var _this = this;

		//activate spinner
		this.isLoading = true;
		$scope.getUserAppsIsDone = false;
		this.userProfileService = userProfileService;
		$scope.demoNum = 1;
		$scope.event_content_show = false;
		$scope.widgetData = [];

		$scope.editWidgetModalPopup = function(availableData, resourceType) {

			$scope.editData = JSON.stringify(availableData);
			$scope.availableDataTemp = $scope.availableData;
			ngDialog.open({
						templateUrl : 'app/views/dashboard/dashboard-widget-manage.html',
						controller : 'CommonWidgetController',
						resolve : {
							message : function message() {
								var message = {
									type : resourceType,
									availableData : $scope.editData
								};
								return message;
							}
						}
					}).closePromise.then(needUpdate => {	
						if(resourceType=='NEWS'){
							$scope.updateNews();
						}else if(resourceType=='EVENTS'){
							$scope.updateEvents();
						}else if(resourceType=='IMPORTANTRESOURCES'){
							$scope.updateImportRes();
						}
	                });		
		};
		/*Setting News data*/
		$scope.importResData = [];
		$scope.updateImportRes = function() {
			$scope.importResData.length=0;
			dashboardService.getCommonWidgetData('IMPORTANTRESOURCES').then(
					function(res) {
						// $log.error('couldnt get important list...',
						// res.response.dataBlob);
						// $log.info(res);
						var importResDataJSONArray = res.response.items;
						for (var i = 0; i < importResDataJSONArray.length; i++) {
							$scope.importResData.push(importResDataJSONArray[i]);
						}
					})['catch'](function(err) {
				$log.error('dashboard controller: failed to get resources list...', err);
				_this.isLoading = false;
			});
		}
		$scope.updateImportRes();

	};
	ResourcesWidget.controller.$inject = ['$rootScope', 'applicationsService','$log', '$window',  'userProfileService', '$scope', '$cookies', '$timeout', '$interval', '$uibModal', 'dashboardService', 'ngDialog'];
	
